module;

#include <windows.h>

export module pige.winapi:application;

export import :window;

export namespace pige::winapi
{
	class first_app
	{
	private:
		window m_window;

	public:
		inline first_app(HINSTANCE instance)
			: m_window{ instance, L"Hello Classes!" }
		{}

		[[nodiscard]] int run()
		{
			MSG msg{};
			BOOL result;
			while (0 < (result = GetMessageW(&msg, nullptr, 0, 0)))
			{
				//Posts WM_*CHAR messages in response to WM_*KEY* messages
				TranslateMessage(&msg);

				//For other things that sometimes go into the message loop, see:
				//https://learn.microsoft.com/en-us/windows/win32/winmsg/using-messages-and-message-queues

				DispatchMessageW(&msg);
			}
			return static_cast<int>(msg.wParam);
		}
	};
}