import pige.winapi;
import std;

#include <windows.h>

int WINAPI wWinMain(HINSTANCE instance, HINSTANCE, LPWSTR, int show_command)
{
	try {
		pige::winapi::window main_window{ instance, L"Hello WinAPI!" };
		ShowWindow(main_window, show_command);
		pige::winapi::application app{ instance };
		return app.run(main_window);
	}
	catch (pige::winapi::winapi_error &e)
	{
		//handle our own errors
		OutputDebugStringW(e.what().c_str());
	}
	catch (std::exception &e)
	{
		//handle any standard library errors
		OutputDebugStringA(e.what());
	}
	catch (...)
	{
		//catch-all if some other exception happens
		OutputDebugStringW(L"Unknown Error!");
	}
	return 1;
}