module;

#include <windows.h>

export module pige.winapi:application;

export import :window;
import std;

export namespace pige::winapi
{
	//Just like with the window class, any modification to the program's behaviour should be done in a sub-class
	class application
	{
		HINSTANCE m_instance;
	public:
		application(HINSTANCE instance)
			: m_instance{ instance }
		{ }

		[[nodiscard]] int run(window &main_window)
		{
			main_window.m_is_main = true;
			return main_loop();
		}

		[[nodiscard]] HINSTANCE instance() const noexcept { return m_instance; }

	protected:
		[[nodiscard]] virtual int main_loop()
		{
			MSG msg{};
			BOOL result;
			while (0 != (result = GetMessageW(&msg, nullptr, 0, 0)))
			{
				if (result < 0)
					throw winapi::winapi_error{};

				TranslateMessage(&msg);
				DispatchMessageW(&msg);
			}
			return static_cast<int>(msg.wParam);
		}
	};
}