import pige.sample;
import std;

#include <windows.h>

int WINAPI wWinMain(HINSTANCE instance, HINSTANCE, LPWSTR, int show_command)
{
	try {
		pige::samples::app2048 app{ instance };
		return app.run(show_command);
	}
	catch (pige::winapi::winapi_error &e)
	{
		//handle our own errors
		OutputDebugStringW(e.what().c_str());
	}
	catch (std::exception &e)
	{
		//handle any standard library errors
		OutputDebugStringA(e.what());
	}
	catch (...)
	{
		//catch-all if some other exception happens
		OutputDebugStringW(L"Unknown Error!");
	}
	return 1;
}